' $Horde: HordeConduit/HordeSync/memoConduit.vb,v 1.1.1.1 2003/03/05 05:12:29 marcus Exp $
Imports PDStandardLib
Imports PDDirectLib
Imports System.Text
Imports PDDirectLib.EAccessModes

<ComClass(memoConduit.ClassId, memoConduit.InterfaceId, memoConduit.EventsId)> _
Public Class memoConduit
    Inherits baseConduit
#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "24388B87-F9CB-44BF-BC95-489952A73481"
    Public Const InterfaceId As String = "EBF067A1-B536-4BBC-B7BC-0928A9932C5A"
    Public Const EventsId As String = "992B37A7-5EE7-4E9E-9DB1-7F4529F511C4"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
        Me.sName = "Memopad -> Horde Notes"
    End Sub

    Public Overrides Function BeginProcess() As Boolean
        Dim palmSystem As New PDSystemAdapter()
        Dim palmHotSyncInfo As PDHotsyncInfo = palmSystem.PDHotsyncInfo

        MyBase.BeginProcess()
        Dim rpcNotes As Object = HSU.Connect("notes.")

        Select Case palmHotSyncInfo.SyncType
            Case ESyncTypes.eDoNothing
                'Do nothing
            Case ESyncTypes.ePCtoHH
                Try
                    'NOTE: There is a bug that memos get corrupted using the native memo
                    ' record adapter, so use the generic PDRecordAdapter.
                    Dim palmDB As New PDDatabaseQuery()
                    Dim MemoDB As PDRecordAdapter = _
                        palmDB.OpenRecordDatabase("MemoDB", "PDDirect.PDRecordAdapter", _
                                                  eWrite Or eRead Or eShowSecret)
                    Dim x As Integer = 0

                    'First we delete the database, including categories
                    If MemoDB.RecordCount > 0 Then
                        MemoDB.RemoveSet(ERemoveSetType.eRemoveAllRecords)
                    End If
                    Dim AppInfo As Object = MemoDB.ReadAppInfoBlock
                    For x = 0 To 274
                        AppInfo(x) = &H0
                    Next
                    MemoDB.WriteAppInfoBlock(AppInfo)

                    'Define a hash to hold categories and add Unfiled, plus all from default memolist
                    Dim hashCategories As New Hashtable()
                    hashCategories.Add("Unfiled", AddCategory(MemoDB.PDCategories, "Unfiled"))
                    Dim cat As Object, catList As Object = rpcNotes.listCategories
                    For Each cat In catList
                        If Not hashCategories.ContainsKey(cat) Then
                            hashCategories.Add(cat, AddCategory(MemoDB.PDCategories, cat))
                        End If
                    Next

                    'Get a list of memos, adding categories as necessary
                    Dim a As New ASCIIEncoding()
                    Dim memo As Object, memoList As Object = rpcNotes.list
                    For Each memo In memoList
                        Dim sKey As String = rpcNotes.formatCategory(memo.category, memo.memolist_id)
                        If Not hashCategories.ContainsKey(sKey) Then
                            hashCategories.Add(sKey, Me.AddCategory(MemoDB.PDCategories, sKey))
                        End If

                        'Translate CR/LF to just CR
                        memo.body = Replace(memo.body, Chr(13), "")
                        Dim m As New PDMemoDbHHRecord()
                        Dim uid As Object
                        Dim data As Object = a.GetBytes(memo.desc & Chr(10) & Chr(10) & memo.body)
                        MemoDB.Write(uid, CInt(hashCategories(sKey)), 0, data)
                    Next
                    MemoDB = Nothing
                Catch err As SystemException
                    MsgBox("Error: " & err.Message & vbCrLf & err.ToString)
                End Try
            Case ESyncTypes.eHHtoPC
                MsgBox("Memopad does not support Handheld overwrites Horde yet.")
            Case Else
                MsgBox("Memopad does not support Handheld to Horde Syncing yet.")
        End Select
        Return False
    End Function
End Class


